//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.ObservablePropertyTest
{
    
    
    /// <summary>
    /// A class that exposes the IObservablePropertyTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class ObservablePropertyTestProvider : IFeatureProvider
    {
        
        private IObservablePropertyTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(ObservablePropertyTestProvider).Assembly, "ObservablePropertyTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public ObservablePropertyTestProvider(IObservablePropertyTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<SetValueRequestDto, EmptyRequest>("SetValue", SetValue);
            registration.RegisterObservableProperty("FixedValue", GetFixedValue, _implementation);
            registration.RegisterObservableProperty("Alternating", GetAlternating, _implementation);
            registration.RegisterObservableProperty("Editable", GetEditable, _implementation);
        }
        
        /// <summary>
        /// Executes the Set Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest SetValue(SetValueRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.SetValue(request.Value.TryExtract(_server, "org.silastandard/test/ObservablePropertyTest/v1/Command/SetValue/Parameter/Value"));
                return EmptyRequest.Instance;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "value"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/ObservablePropertyTest/v1/Command/SetValue/Parameter/Value", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Fixed Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.IntegerDto> GetFixedValue()
        {
            return new PropertyResponse<Tecan.Sila2.IntegerDto>(new Tecan.Sila2.IntegerDto(_implementation.FixedValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Alternating property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.BooleanDto> GetAlternating()
        {
            return new PropertyResponse<Tecan.Sila2.BooleanDto>(new Tecan.Sila2.BooleanDto(_implementation.Alternating, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Editable property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.IntegerDto> GetEditable()
        {
            return new PropertyResponse<Tecan.Sila2.IntegerDto>(new Tecan.Sila2.IntegerDto(_implementation.Editable, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/ObservablePropertyTest/v1/Command/SetValue"))
            {
                return typeof(IObservablePropertyTest).GetMethod("SetValue");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "org.silastandard/test/ObservablePropertyTest/v1/Property/FixedValue"))
            {
                return typeof(IObservablePropertyTest).GetProperty("FixedValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/ObservablePropertyTest/v1/Property/Alternating"))
            {
                return typeof(IObservablePropertyTest).GetProperty("Alternating");
            }
            if ((propertyIdentifier == "org.silastandard/test/ObservablePropertyTest/v1/Property/Editable"))
            {
                return typeof(IObservablePropertyTest).GetProperty("Editable");
            }
            return null;
        }
    }
}

